# `TaurusBaseContainer`

digraph inheritance9aa9f71875 { bgcolor=transparent; rankdir=UD; ratio=compress; size="8.0, 12.0"; "BaseConfigurableClass" [URL="taurus.qt.qtcore.configuration-BaseConfigurableClass.html#taurus.qt.qtcore.configuration.BaseConfigurableClass",color=dodgerblue1,fillcolor=white,fontcolor=black,fontname="Vera Sans, DejaVu Sans, Liberation Sans, Arial, Helvetica, sans",fontsize=10,height=0.5,shape=box,style=rounded,target="_top",tooltip="A base class defining the API for configurable objects."]; "Logger" [URL="taurus-Logger.html#taurus.Logger",color=dodgerblue1,fillcolor=white,fontcolor=black,fontname="Vera Sans, DejaVu Sans, Liberation Sans, Arial, Helvetica, sans",fontsize=10,height=0.5,shape=box,style=rounded,target="_top",tooltip="The taurus logger class. All taurus pertinent classes should inherit"]; "TaurusBaseComponent" [URL="taurus.qt.qtgui.base-TaurusBaseComponent.html#taurus.qt.qtgui.base.TaurusBaseComponent",color=dodgerblue1,fillcolor=white,fontcolor=black,fontname="Vera Sans, DejaVu Sans, Liberation Sans, Arial, Helvetica, sans",fontsize=10,height=0.5,shape=box,style=rounded,target="_top",tooltip="A generic Taurus component."]; "TaurusListener" -> "TaurusBaseComponent" [arrowsize=0.5,style="setlinewidth(0.5)"]; "BaseConfigurableClass" -> "TaurusBaseComponent" [arrowsize=0.5,style="setlinewidth(0.5)"]; "TaurusBaseContainer" [URL="#taurus.qt.qtgui.container.TaurusBaseContainer",color=dodgerblue1,fillcolor=white,fontcolor=black,fontname="Vera Sans, DejaVu Sans, Liberation Sans, Arial, Helvetica, sans",fontsize=10,height=0.5,shape=box,style=rounded,target="_top",tooltip="Base class for the Taurus container widgets. This type of taurus"]; "TaurusBaseWidget" -> "TaurusBaseContainer" [arrowsize=0.5,style="setlinewidth(0.5)"]; "TaurusBaseWidget" [URL="taurus.qt.qtgui.base-TaurusBaseWidget.html#taurus.qt.qtgui.base.TaurusBaseWidget",color=dodgerblue1,fillcolor=white,fontcolor=black,fontname="Vera Sans, DejaVu Sans, Liberation Sans, Arial, Helvetica, sans",fontsize=10,height=0.5,shape=box,style=rounded,target="_top",tooltip="The base class for all Qt Taurus widgets."]; "TaurusBaseComponent" -> "TaurusBaseWidget" [arrowsize=0.5,style="setlinewidth(0.5)"]; "TaurusListener" [URL="taurus.core.tauruslistener-TaurusListener.html#taurus.core.tauruslistener.TaurusListener",color=dodgerblue1,fillcolor=white,fontcolor=black,fontname="Vera Sans, DejaVu Sans, Liberation Sans, Arial, Helvetica, sans",fontsize=10,height=0.5,shape=box,style=rounded,target="_top",tooltip="TaurusListener Interface"]; "Logger" -> "TaurusListener" [arrowsize=0.5,style="setlinewidth(0.5)"]; }

class TaurusBaseContainer(name='', parent=None, designMode=False)

  Base class for the Taurus container widgets. This type of taurus container classes are specially useful if you define a parent taurus model to them and set all contained taurus widgets to use parent model. Example:

      from taurus.qt.qtgui.container import TaurusWidget
      from taurus.qt.qtgui.display import TaurusLabel

      widget = TaurusWidget()
      layout = Qt.QVBoxLayout()
      widget.setLayout(layout)
      widget.model = 'sys/database/2'
      stateWidget = TaurusLabel()
      layout.addWidget(stateWidget)
      stateWidget.model = 'sys/database/2/state'

  Import from `taurus.qt.qtgui.container` as:

      from taurus.qt.qtgui.container import TaurusBaseContainer

  defineStyle()
  getPendingOperations()

    Returns the sequence of pending operations

    Returns:

      a list of pending operations

    Return type:

      sequence<taurus.core.taurusoperation.TaurusOperation>

  handleEvent(evt_src, evt_type, evt_value)

    very basic and generalistic handling of events.

    Override when necessary.

    Parameters:

      - evt_src (object or None) – object that triggered the event

      - evt_type (taurus.core.taurusbasetypes.TaurusEventType or None) – type of event

      - evt_value (object or None) – event value

  hasPendingOperations()

    Returns if the component has pending operations

    Returns:

      True if there are pending operations or False otherwise

    Return type:

      bool

  isReadOnly()

    Determines if this component is read-only or not in the sense that the user can interact with it. Default implementation returns True.

    Override when necessary.

    Returns:

      whether or not this component is read-only

    Return type:

      bool

  resetPendingOperations()

    Clears the list of pending operations

  sizeHint()
  taurusChildren(objs=None)

    returns a list of all taurus children of this taurus container (recurses down skipping non-taurus widgets)

    Parameters:

      objs (list<objects>) – if given, the search starts at the objects passed in this list

    Returns:

    Return type:

      list<TaurusBaseWidget>

  updateStyle()

    Updates the widget style. Default implementation just calls QWidget.update()

    Override when necessary.